Package org.apache.storm.command

## Class CLI

- java.lang.Object
- - org.apache.storm.command.CLI

-     public class CLI
      extends Object

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static interface` | `CLI.Assoc` |
    `static class` | `CLI.CLIBuilder` |
    `static interface` | `CLI.Parse` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static CLI.Parse` | `AS_INT` | Parse function to return an Integer.
    `static CLI.Parse` | `AS_STRING` | Noop parse function, returns the String.
    `static CLI.Assoc` | `FIRST_WINS` | First occurrence on the command line is the resulting value.
    `static CLI.Assoc` | `INTO_LIST` | All values are returned as a List.
    `static CLI.Assoc` | `INTO_MAP` | All values are returned as a map.
    `static CLI.Assoc` | `LAST_WINS` | Last occurrence on the command line is the resulting value.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CLI()` |

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static CLI.CLIBuilder` | `arg​(String name)` | Add a named argument.
    `static CLI.CLIBuilder` | `arg​(String name, CLI.Assoc assoc)` | Add a named argument.
    `static CLI.CLIBuilder` | `arg​(String name, CLI.Parse parse)` | Add a named argument.
    `static CLI.CLIBuilder` | `arg​(String name, CLI.Parse parse, CLI.Assoc assoc)` | Add a named argument.
    `static CLI.CLIBuilder` | `boolOpt​(String shortName, String longName)` | Add a boolean option that enables something.
    `static CLI.CLIBuilder` | `opt​(String shortName, String longName, Object defaultValue)` | Add an option to be parsed.
    `static CLI.CLIBuilder` | `opt​(String shortName, String longName, Object defaultValue, CLI.Parse parse)` | Add an option to be parsed.
    `static CLI.CLIBuilder` | `opt​(String shortName, String longName, Object defaultValue, CLI.Parse parse, CLI.Assoc assoc)` | Add an option to be parsed.
    `static CLI.CLIBuilder` | `optionalArg​(String name)` | Add a named argument that is optional.
    `static CLI.CLIBuilder` | `optionalArg​(String name, CLI.Assoc assoc)` | Add a named argument that is optional.
    `static CLI.CLIBuilder` | `optionalArg​(String name, CLI.Parse parse)` | Add a named argument that is optional.
    `static CLI.CLIBuilder` | `optionalArg​(String name, CLI.Parse parse, CLI.Assoc assoc)` | Add a named argument that is optional.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### AS_INT

          public static final CLI.Parse AS_INT

      Parse function to return an Integer.

    - #### AS_STRING

          public static final CLI.Parse AS_STRING

      Noop parse function, returns the String.

    - #### LAST_WINS

          public static final CLI.Assoc LAST_WINS

      Last occurrence on the command line is the resulting value.

    - #### FIRST_WINS

          public static final CLI.Assoc FIRST_WINS

      First occurrence on the command line is the resulting value.

    - #### INTO_LIST

          public static final CLI.Assoc INTO_LIST

      All values are returned as a List.

    - #### INTO_MAP

          public static final CLI.Assoc INTO_MAP

      All values are returned as a map.

  - ### Constructor Detail

    - #### CLI

          public CLI()

  - ### Method Detail

    - #### opt

          public static CLI.CLIBuilder opt​(String shortName,
                                           String longName,
                                           Object defaultValue)

      Add an option to be parsed.
      Parameters:
        `shortName` - the short single character name of the option (no `-` character proceeds it).
        `longName` - the multi character name of the option (no `--` characters proceed it).
        `defaultValue` - the value that will be returned of the command if none is given. null if none is given.
      Returns:
        a builder to be used to continue creating the command line.

    - #### opt

          public static CLI.CLIBuilder opt​(String shortName,
                                           String longName,
                                           Object defaultValue,
                                           CLI.Parse parse)

      Add an option to be parsed.
      Parameters:
        `shortName` - the short single character name of the option (no `-` character proceeds it).
        `longName` - the multi character name of the option (no `--` characters proceed it).
        `defaultValue` - the value that will be returned of the command if none is given. null if none is given.
        `parse` - an optional function to transform the string to something else. If null a NOOP is used.
      Returns:
        a builder to be used to continue creating the command line.

    - #### opt

          public static CLI.CLIBuilder opt​(String shortName,
                                           String longName,
                                           Object defaultValue,
                                           CLI.Parse parse,
                                           CLI.Assoc assoc)

      Add an option to be parsed.
      Parameters:
        `shortName` - the short single character name of the option (no `-` character proceeds it).
        `longName` - the multi character name of the option (no `--` characters proceed it).
        `defaultValue` - the value that will be returned of the command if none is given. null if none is given.
        `parse` - an optional function to transform the string to something else. If null a NOOP is used.
        `assoc` - an association command to decide what to do if the option appears multiple times. If null LAST_WINS is used.
      Returns:
        a builder to be used to continue creating the command line.

    - #### boolOpt

          public static CLI.CLIBuilder boolOpt​(String shortName,
                                               String longName)

      Add a boolean option that enables something.
      Parameters:
        `shortName` - the short single character name of the option (no `-` character proceeds it).
        `longName` - the multi character name of the option (no `--` characters proceed it).
      Returns:
        a builder to be used to continue creating the command line.

    - #### arg

          public static CLI.CLIBuilder arg​(String name)

      Add a named argument.
      Parameters:
        `name` - the name of the argument.
      Returns:
        a builder to be used to continue creating the command line.

    - #### arg

          public static CLI.CLIBuilder arg​(String name,
                                           CLI.Assoc assoc)

      Add a named argument.
      Parameters:
        `name` - the name of the argument.
        `assoc` - an association command to decide what to do if the argument appears multiple times. If null INTO_LIST is used.
      Returns:
        a builder to be used to continue creating the command line.

    - #### arg

          public static CLI.CLIBuilder arg​(String name,
                                           CLI.Parse parse)

      Add a named argument.
      Parameters:
        `name` - the name of the argument.
        `parse` - an optional function to transform the string to something else. If null a NOOP is used.
      Returns:
        a builder to be used to continue creating the command line.

    - #### arg

          public static CLI.CLIBuilder arg​(String name,
                                           CLI.Parse parse,
                                           CLI.Assoc assoc)

      Add a named argument.
      Parameters:
        `name` - the name of the argument.
        `parse` - an optional function to transform the string to something else. If null a NOOP is used.
        `assoc` - an association command to decide what to do if the argument appears multiple times. If null INTO_LIST is used.
      Returns:
        a builder to be used to continue creating the command line.

    - #### optionalArg

          public static CLI.CLIBuilder optionalArg​(String name)

      Add a named argument that is optional.
      Parameters:
        `name` - the name of the argument.
      Returns:
        a builder to be used to continue creating the command line.

    - #### optionalArg

          public static CLI.CLIBuilder optionalArg​(String name,
                                                   CLI.Assoc assoc)

      Add a named argument that is optional.
      Parameters:
        `name` - the name of the argument.
        `assoc` - an association command to decide what to do if the argument appears multiple times. If null INTO_LIST is used.
      Returns:
        a builder to be used to continue creating the command line.

    - #### optionalArg

          public static CLI.CLIBuilder optionalArg​(String name,
                                                   CLI.Parse parse)

      Add a named argument that is optional.
      Parameters:
        `name` - the name of the argument.
        `parse` - an optional function to transform the string to something else. If null a NOOP is used.
      Returns:
        a builder to be used to continue creating the command line.

    - #### optionalArg

          public static CLI.CLIBuilder optionalArg​(String name,
                                                   CLI.Parse parse,
                                                   CLI.Assoc assoc)

      Add a named argument that is optional.
      Parameters:
        `name` - the name of the argument.
        `parse` - an optional function to transform the string to something else. If null a NOOP is used.
        `assoc` - an association command to decide what to do if the argument appears multiple times. If null INTO_LIST is used.
      Returns:
        a builder to be used to continue creating the command line.